# PF

## Introductie

PF is de opvolger van Purefaçade.
Purefaçade maakte het eenvoudig mogelijk om data uit de Pure webservices beschikbaar te krijgen in de website,
in de vorm van HTML, RSS of vCards.
Purefaçade bood veel mogelijkheden.
Een aantal ervan kunnen worden overgenomen door de nieuwe Pure Portal.
Veel opties werden in de praktijk niet gebruikt.
Sommige opties waren nuttig toen Purefaçade gebouwd werd, maar zijn dat nu niet meer.
Caching, bijvoorbeeld, was in het begin nodig omdat Pure heel traag was.
Nu zit caching meer in de weg dan dat het nuttig is.
Pure heeft een eenvoudiger API gekregen, wat het parsen van de output van de webservices zeer sterk heeft vereenvoudigd.
PF gebruikt de nieuwe API van Pure webservices.
Verder wordt nu de APA-rendering van Pure zelf gebruikt, wat zeer veel programmatuur scheelt.
PF is daarom een systeem dat maar een paar dingen kan, en met veel minder opties.

```
+-----------+   +-----------+   +-----------+   +-----------+   +-----------+
| Applicatie|   | PF        |   | Pure      |   | Pure      |   | Bezoeker  | 
| of        <---+           <---+ web-      +---> Portal    +---> of        |
| browser   |   |           |   | services  |   |           |   | applicatie|
+-----------+   +-----------+   +-----^-----+   +-----------+   +-----------+
                                      |
                                      |
                                      |
                                +-----+-----+
                                | Pure      |
                                |           |
                                |           |
                                +-----------+
```

## Beperkte toegang

Toegang tot de service kan beperkt zijn om persoonsdata af te schermen en om te voorkomen dat getoonde gegevens in Webwijs worden aangepast.

## Features

- Series, zoals CentER Discussion Paper-series, voor een jaar, gesorteerd op afnemend volume als RSS
- UUID van wetenschapper gegeven de mailnaam
- Data medewerkers t.b.v. Experts & Expertise (Webwijs)

## Gebruik

Alle getoonde URLs en links in de voorbeelden zijn herschreven naar de omgeving waar PF draait.

### GET /persons/select?id=[ANR]...

Experts & Expertise-data van een aantal personen

Geeft de actuele XML van een selectie van personen.
Data komt niet uit de cache.

Geef 1 of meer ANR's op via herhaalde '&id=<ANR>' request-parameters.

Voorbeeld: [${pf.base-url}/persons/select?id=178071](${pf.base-url}/persons/select?id=178071) : de XML van Fred Vos

### POST /persons/update

Forceer een update van de Experts & Expertise-data in de cache

Stuur als content text/plain een geheime string mee, ingesteld als 'pf.ee-data.update-command' in de configuratie.
Werkt alleen als de job op dat moment niet bezig is.
Geeft terug 'Triggered' indien gestart en 'Busy' als job al/nog loopt.

### POST /persons/upload

Upload een XML-bestand naar de cache

Stuur als content application/xml mee.
Het wordt alleen geaccepteerd als de job voor vervangen niet loopt.
Bestand wordt geparsed en dan geplaatst als 'newest', met automatisch aangepaste creation-date (upload-moment).
Indien het aan de eisen voldoet, dan wordt het ook als 'latest-stable' opgeslagen.

Deze optie is er tijdelijk in verband met tests.
Op termijn verdwijnt deze optie weer.

### GET /persons/cache-file-statistics

Statistieken over nieuwste en laatste goedgekeurde XML van Experts & Expertise-data

Geeft application/xml terug.

Voorbeeld: [${pf.base-url}/persons/cache-file-statistics](${pf.base-url}/persons/cache-file-statistics) 

### GET /persons/ee-data-cache-latest-stable

Laatste stabiele (=goedgekeurde) versie van de Experts & Expertise-data

Geeft application/xml terug (groot bestand).

Voorbeeld: [${pf.base-url}/persons/ee-data-cache-latest-stable](${pf.base-url}/persons/ee-data-cache-latest-stable) 

### GET /persons/ee-data-cache-newest

Nieuwste versie van de Experts & Expertise-data

Deze is dezelfde als 'latest stable' indien goedgekeurd.
Wanneer niet goedgekeurd, wordt dit bestand niet gekopieerd naar 'latest stable'.

Geeft application/xml terug (groot bestand).

Voorbeeld: [${pf.base-url}/persons/ee-data-cache-newest](${pf.base-url}/persons/ee-data-cache-newest) 

### GET /persons/person;mailname=[MAILNAAM]/uuid

UUID van wetenschapper gegeven de mailnaam

Mailnaam is case-insensitive.

Voorbeeld: [${pf.base-url}/persons/person;mailname=T.A.Klimstra/uuid](${pf.base-url}/persons/person;mailname=T.A.Klimstra/uuid) : UUID van Theo Klimstra

### GET /series?series=[NAAM-SERIES]&publication-year=[JAAR]&document-type={discussionpaper|thesisdoc}

Series van een jaar compleet als RSS

Een RSS feed van publicaties van een zekere serie voor een jaar.
Publicaties gesorteerd op afnemend volume.

Alle request parameters zijn verplicht.

Request parameter value voor 'series' moet letterlijk overeenstemmen met die vastgelegd in Pure, maar is wel case insensitive.

Request parameter value voor 'publication-year' is het jaar in vier cijfers.

Request parameter value voor 'document-type' is een van de opties zoals - door pipe-tekens gescheiden - bij URL beschreven.
Elke andere waarde is niet correct.
De programmatuur vertaalt deze verkorte namen naar de lange URI die Pure intern aanhoudt voor document type.

Dit verzoek leidt in de regel tot meerdere verzoeken aan Pure, waarbij veel meer wordt opgehaald dan nodig is.
Achteraf wordt er dan gefilterd.
Daardoor is dit verzoek relatief traag met antwoorden.
Indien mogelijk, dan de frequentie van opvragen beperken; bijvoorbeeld niet elke 5 minuten hernieuwd opvragen als een pagina open blijft staan.

Let op dat je heel precies alle request-parameters benoemt.
Een typo in bijvoorbeeld 'publication-year' maakt dat **alle** publicaties worden opgehaald.
Dat duurt vreselijk lang en kan service doen hangen.

Voorbeelden:

- [${pf.base-url}/series?series=CentER%20Discussion%20Paper&publication-year=2014&document-type=discussionpaper](${pf.base-url}/series?series=CentER%20Discussion%20Paper&publication-year=2014&document-type=discussionpaper) : CentER Discussion Paper series van 2014
  
- [${pf.base-url}/series?series=CentER%20Dissertation%20Series&publication-year=2016&document-type=thesisdoc](${pf.base-url}/series?series=CentER%20Dissertation%20Series&publication-year=2016&document-type=thesisdoc) : CentER Dissertation Series van 2016

- [${pf.base-url}/series?series=TiCC%20Ph.D.%20Series&publication-year=2017&document-type=thesisdoc](${pf.base-url}/series?series=TiCC%20Ph.D.%20Series&publication-year=2017&document-type=thesisdoc) : TiCC Ph.D. Series van 2017

### /status

Status van PF

Kan zowel text/html als application/xml geven.
Applicaties kunnen aangeven dat ze application/xml willen.

Voorbeeld: [${pf.base-url}/status](${pf.base-url}/status)

## Verder

### Release notes

Deze vind je [hier](release-notes).

### Roadmap

Deze vind je [hier](roadmap).
